﻿Type=Class
Version=0.1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
  Type TileRec(zm, x, y As Int, svr As String)
  Type SvrsRec(nm, zl As String, sv As List)
  
  Dim Servers As List

  Public TileCache As List ' init'e with tiles to fetch (TileRecs)
  Public SvrCache As List ' holds server URLs available (URL strings with placeholders (*z, *x, *y))
  
  Private ogTasks As Map ' when job created holds "Jobname=TileRec"

  Private fx As JFX
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
  TileCache.Initialize
  SvrCache.Initialize
  ogTasks.Initialize
  Servers.Initialize
  
  InitSvrs
End Sub

' Name					URL template													zoomlevels
' CloudMade (Fine line)	http://[abc].tile.cloudmade.com/your_CloudMade_API_key/2/256/zoom/x/y.png 0-18
' CloudMade (NoNames)	http://[abc].tile.cloudmade.com/your_CloudMade_API_key/3/256/zoom/x/y.png 0-18
' CloudMade (Web style)	http://[abc].tile.cloudmade.com/your_CloudMade_API_key/1/256/zoom/x/y.png 0-18
' MapQuest				http://otile[1234].mqcdn.com/tiles/1.0.0/osm/zoom/x/y.jpg		0-19
' MapQuest Open Aerial	http://otile[1234].mqcdn.com/tiles/1.0.0/sat/zoom/x/y.jpg		0-11 globally, 12+ In the U.S.
' Migurski's Terrain	http://tile.stamen.com/terrain-background/zoom/x/y.jpg			4-18, US-only (for now)
' OpenCycleMap			http://[abc].tile.opencyclemap.org/cycle/zoom/x/y.png			0-18
' OpenCycleMap Transport http://[abc].tile2.opencyclemap.org/transport/zoom/x/y.png		0-18
' OSM 'standard' style	http://[abc].tile.openstreetmap.org/zoom/x/y.png				0-19

Public Sub InitSvrs
  Servers.Initialize
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "CloudMade (Fine line)"
  sr.zl = "0-18"
  
  sr.sv.Add("http://a.tile.cloudmade.com/your_CloudMade_API_key/2/256/*z/*x/*y.png")
  sr.sv.Add("http://b.tile.cloudmade.com/your_CloudMade_API_key/2/256/*z/*x/*y.png")
  sr.sv.Add("http://c.tile.cloudmade.com/your_CloudMade_API_key/2/256/*z/*x/*y.png")

  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "CloudMade (NoNames)"
  sr.zl = "0-18"
  
  sr.sv.Add("http://a.tile.cloudmade.com/your_CloudMade_API_key/3/256/*z/*x/*y.png")
  sr.sv.Add("http://b.tile.cloudmade.com/your_CloudMade_API_key/3/256/*z/*x/*y.png")
  sr.sv.Add("http://c.tile.cloudmade.com/your_CloudMade_API_key/3/256/*z/*x/*y.png")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "CloudMade (Web style)"
  sr.zl = "0-18"
  
  sr.sv.Add("http://a.tile.cloudmade.com/your_CloudMade_API_key/1/256/*z/*x/*y.png")
  sr.sv.Add("http://b.tile.cloudmade.com/your_CloudMade_API_key/1/256/*z/*x/*y.png")
  sr.sv.Add("http://c.tile.cloudmade.com/your_CloudMade_API_key/1/256/*z/*x/*y.png")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "MapQuest"
  sr.zl = "0-19"
  
  sr.sv.Add("http://otile1.mqcdn.com/tiles/1.0.0/osm/*z/*x/*y.jpg")
  sr.sv.Add("http://otile2.mqcdn.com/tiles/1.0.0/osm/*z/*x/*y.jpg")
  sr.sv.Add("http://otile3.mqcdn.com/tiles/1.0.0/osm/*z/*x/*y.jpg")
  sr.sv.Add("http://otile4.mqcdn.com/tiles/1.0.0/osm/*z/*x/*y.jpg")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "MapQuest Open Aerial"
  sr.zl = "0-11 globally, 12+ In the U.S."
  
  sr.sv.Add("http://otile1.mqcdn.com/tiles/1.0.0/sat/*z/*x/*y.jpg")
'  sr.sv.Add("http://otile2.mqcdn.com/tiles/1.0.0/sat/*z/*x/*y.jpg")
'  sr.sv.Add("http://otile3.mqcdn.com/tiles/1.0.0/sat/*z/*x/*y.jpg")
'  sr.sv.Add("http://otile4.mqcdn.com/tiles/1.0.0/sat/*z/*x/*y.jpg")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "Migurski's Terrain"
  sr.zl = "4-18, US-only (for now)"
  
  sr.sv.Add("http://tile.stamen.com/terrain-background/*z/*x/*y.jpg")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "OpenCycleMap"
  sr.zl = "0-18"
  
  sr.sv.Add("http://a.tile.opencyclemap.org/cycle/*z/*x/*y.png")
  sr.sv.Add("http://b.tile.opencyclemap.org/cycle/*z/*x/*y.png")
  sr.sv.Add("http://c.tile.opencyclemap.org/cycle/*z/*x/*y.png")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "OpenCycleMap Transport"
  sr.zl = "0-18"
  
  sr.sv.Add("http://a.tile2.opencyclemap.org/transport/*z/*x/*y.png")
  sr.sv.Add("http://b.tile2.opencyclemap.org/transport/*z/*x/*y.png")
  sr.sv.Add("http://c.tile2.opencyclemap.org/transport/*z/*x/*y.png")
  
  Dim sr As SvrsRec
  sr.Initialize
  sr.sv.Initialize
  Servers.Add(sr)
  
  sr.nm = "OSM 'standard' style"
  sr.zl = "0-19"
  
  sr.sv.Add("http://a.tile.openstreetmap.org/*z/*x/*y.png")
  sr.sv.Add("http://b.tile.openstreetmap.org/*z/*x/*y.png")
  sr.sv.Add("http://c.tile.openstreetmap.org/*z/*x/*y.png")
End Sub

Public Sub SelSvrs(svr As String)
  Dim sr As SvrsRec
  
  SvrCache.Clear
  
  For i=0 To Servers.Size-1
    sr = Servers.Get(i)
	
    If (sr.nm = svr) Then
	  SvrCache.AddAll(sr.sv)
	  Exit
	End If
  Next
End Sub

Public Sub Download ' check if svrs avail, create jobs, clr AllDone
  Do While (True)
    If ((SvrCache.Size > 0) AND (TileCache.Size > 0)) Then
	  Dim i As Int
	  Dim s, t, u As String
	  Dim tr As TileRec
	  
	  tr.Initialize
	  
	  i = SvrCache.Size - 1
	  s = SvrCache.Get(i)
	  SvrCache.RemoveAt(i)
	  
	  i = TileCache.Size - 1
	  tr = TileCache.Get(i)
	  TileCache.RemoveAt(i)
	  
	  t = s.Replace("*z", tr.zm).Replace("*x", tr.x).Replace("*y", tr.y)
	  u = tr.zm & "_" & tr.x & "_" & tr.y
	  
	  Log(t)

      Dim hj As HttpJob
      hj.Initialize(u, Me)
      hj.Download(t)
      tr.svr = s
      ogTasks.Put(u, tr)
	Else
      Exit	  
	End If
  Loop
End Sub

Sub JobDone(hj As HttpJob) ' re-insert svr to SvrCache, test for AllDone
  Dim tr As TileRec
  
  tr.Initialize
  
  tr = ogTasks.Get(hj.JobName)
  SvrCache.Add(tr.svr)
  ogTasks.Remove(hj.JobName)
  
  If (hj.Success = True) Then
    Dim s, fd As String
    Dim bm As Image
	Dim os As OutputStream
	
	bm = hj.GetBitmap
	
	s = tr.zm & "/" & tr.x
	fd = File.DirApp & "/" & s
	If (File.Exists(fd, "") = False) Then File.MakeDir(File.DirApp, s)
	
	os = File.OpenOutput(fd, tr.y & ".png", False)
	bm.WriteToStream(os)
	os.Close
  Else
    Log("Image download Error : " & hj.JobName & CRLF & hj.ErrorMessage)
  End If
    
  hj.Release
End Sub

Public Sub ActivityIsPaused
End Sub
